Index: builtin/src/main/java/org/hippoecm/frontend/plugins/standardworkflow/FolderWorkflowPlugin.java
IDEA additional info:
Subsystem: com.intellij.openapi.diff.impl.patch.CharsetEP
<+>UTF-8
===================================================================
--- builtin/src/main/java/org/hippoecm/frontend/plugins/standardworkflow/FolderWorkflowPlugin.java	(revision 48312)
+++ builtin/src/main/java/org/hippoecm/frontend/plugins/standardworkflow/FolderWorkflowPlugin.java	(revision )
@@ -36,7 +36,6 @@
 import org.apache.wicket.markup.repeater.data.IDataProvider;
 import org.apache.wicket.markup.repeater.data.ListDataProvider;
 import org.apache.wicket.model.IModel;
-import org.apache.wicket.model.LoadableDetachableModel;
 import org.apache.wicket.model.StringResourceModel;
 import org.apache.wicket.request.resource.PackageResource;
 import org.apache.wicket.request.resource.PackageResourceReference;
@@ -46,6 +45,7 @@
 import org.hippoecm.addon.workflow.IWorkflowInvoker;
 import org.hippoecm.addon.workflow.StdWorkflow;
 import org.hippoecm.addon.workflow.WorkflowDescriptorModel;
+import org.hippoecm.frontend.dialog.DialogConstants;
 import org.hippoecm.frontend.dialog.IDialogService.Dialog;
 import org.hippoecm.frontend.i18n.model.NodeTranslator;
 import org.hippoecm.frontend.model.JcrNodeModel;
@@ -55,11 +55,11 @@
 import org.hippoecm.frontend.service.IBrowseService;
 import org.hippoecm.frontend.service.IEditor;
 import org.hippoecm.frontend.service.IEditorManager;
-import org.hippoecm.frontend.service.ISettingsService;
 import org.hippoecm.frontend.service.ServiceException;
 import org.hippoecm.frontend.service.render.RenderPlugin;
 import org.hippoecm.frontend.session.UserSession;
 import org.hippoecm.frontend.translation.ILocaleProvider;
+import org.hippoecm.frontend.util.CodecUtils;
 import org.hippoecm.frontend.widgets.AbstractView;
 import org.hippoecm.repository.api.Document;
 import org.hippoecm.repository.api.HippoNode;
@@ -67,7 +67,6 @@
 import org.hippoecm.repository.api.HippoWorkspace;
 import org.hippoecm.repository.api.Localized;
 import org.hippoecm.repository.api.StringCodec;
-import org.hippoecm.repository.api.StringCodecFactory;
 import org.hippoecm.repository.api.Workflow;
 import org.hippoecm.repository.api.WorkflowDescriptor;
 import org.hippoecm.repository.api.WorkflowException;
@@ -91,7 +90,7 @@
 
         try {
             WorkflowDescriptorModel model = getModel();
-            List<StdWorkflow> list = new LinkedList<StdWorkflow>();
+            List<StdWorkflow> list = new LinkedList<>();
             WorkflowDescriptor descriptor = model.getObject();
             WorkflowManager manager = UserSession.get().getWorkflowManager();
             Workflow workflow = manager.getWorkflow(descriptor);
@@ -139,7 +138,7 @@
                         // and there is some logic here to look up the parent.  The real solution is
                         // in the visual component to merge two workflows.
                         HippoNode node = (HippoNode) model.getNode();
-                        String nodeName = getNodeNameCodec().encode(renameDocumentModel.getUriName());
+                        String nodeName = getNodeNameCodec(node).encode(renameDocumentModel.getUriName());
                         String localName = getLocalizeCodec().encode(renameDocumentModel.getTargetName());
                         WorkflowManager manager = UserSession.get().getWorkflowManager();
                         DefaultWorkflow defaultWorkflow = (DefaultWorkflow) manager.getWorkflow("core", node);
@@ -156,7 +155,7 @@
 
             if (isActionAvailable("reorder", hints)) {
                 add(new StdWorkflow("reorder", new StringResourceModel("reorder-folder", this, null), context, getModel()) {
-                    public List<String> order = new LinkedList<String>();
+                    public List<String> order = new LinkedList<>();
 
                     @Override
                     protected ResourceReference getIcon() {
@@ -171,7 +170,7 @@
                     @Override
                     protected void execute(WorkflowDescriptorModel model) throws Exception {
                         WorkflowManager manager = UserSession.get().getWorkflowManager();
-                        FolderWorkflow workflow = (FolderWorkflow) manager.getWorkflow((WorkflowDescriptor) model.getObject());
+                        FolderWorkflow workflow = (FolderWorkflow) manager.getWorkflow(model.getObject());
                         workflow.reorder(order);
                     }
                 });
@@ -232,13 +231,13 @@
                         }
 
                         @Override
-                        public IModel getTitle() {
+                        public IModel<String> getTitle() {
                             return new StringResourceModel("delete-title", FolderWorkflowPlugin.this, null);
                         }
 
                         @Override
                         public IValueMap getProperties() {
-                            return SMALL;
+                            return DialogConstants.SMALL;
                         }
                     }
 
@@ -255,7 +254,7 @@
                 });
             }
 
-            final Set<String> translated = new TreeSet<String>();
+            final Set<String> translated = new TreeSet<>();
             if (getPluginConfig().containsKey("workflow.translated")) {
                 Collections.addAll(translated, getPluginConfig().getStringArray("workflow.translated"));
             }
@@ -301,13 +300,13 @@
                                     log.error("unknown folder type " + addDocumentModel.getPrototype());
                                     return "Unknown folder type " + addDocumentModel.getPrototype();
                                 }
-                                String nodeName = getNodeNameCodec().encode(addDocumentModel.getUriName());
+                                String nodeName = getNodeNameCodec(getModel().getNode()).encode(addDocumentModel.getUriName());
                                 String localName = getLocalizeCodec().encode(addDocumentModel.getTargetName());
                                 if ("".equals(nodeName)) {
                                     throw new IllegalArgumentException("You need to enter a name");
                                 }
 
-                                TreeMap<String, String> arguments = new TreeMap<String, String>();
+                                TreeMap<String, String> arguments = new TreeMap<>();
                                 arguments.put("name", nodeName);
                                 arguments.put("localName", localName);
 
@@ -354,17 +353,17 @@
     }
 
     protected Dialog newRenameDocumentDialog(RenameDocumentArguments renameDocumentModel, IWorkflowInvoker invoker) {
+
+        String locale = getCodecLocale();
+        IModel<StringCodec> codecModel = CodecUtils.getNodeNameCodecModel(getPluginContext(), locale);
+
         return new RenameDocumentDialog(
                 renameDocumentModel,
                 new StringResourceModel("rename-title", this, null),
                 invoker,
-                new LoadableDetachableModel<StringCodec>() {
-                    @Override
-                    protected StringCodec load() {
-                        return getNodeNameCodec();
+                codecModel
+        );
                     }
-                });
-    }
 
     protected boolean isLanguageKnown() {
         WorkflowDescriptorModel descriptorModel = (WorkflowDescriptorModel) getDefaultModel();
@@ -385,24 +384,29 @@
     protected AddDocumentDialog createAddDocumentDialog(AddDocumentArguments addDocumentModel,
                                                      String category, Set<String> prototypes, boolean translated,
                                                      IWorkflowInvoker invoker) {
-        return new AddDocumentDialog(
+        String locale = getCodecLocale();
+        IModel<StringCodec> codecModel = CodecUtils.getNodeNameCodecModel(getPluginContext(), locale);
+
+        AddDocumentDialog dialog = new AddDocumentDialog(
                 addDocumentModel,
                 new StringResourceModel(category, this, null),
                 category,
                 prototypes,
                 translated && !isLanguageKnown(),
                 invoker,
-                new LoadableDetachableModel<StringCodec>() {
-                    @Override
-                    protected StringCodec load() {
-                        return getNodeNameCodec();
+                codecModel,
+                getLocaleProvider()
+        );
+
+        if (locale != null) {
+            dialog.getLanguageField().setVisible(false);
                     }
-                },
-                getLocaleProvider());
+
+        return dialog;
     }
 
     protected IDataProvider<StdWorkflow> createListDataProvider(List<StdWorkflow> list) {
-        return new ListDataProvider<StdWorkflow>(list);
+        return new ListDataProvider<>(list);
     }
 
     @SuppressWarnings("unchecked")
@@ -470,21 +474,25 @@
     }
 
     protected StringCodec getLocalizeCodec() {
-        ISettingsService settingsService = getPluginContext().getService(ISettingsService.SERVICE_ID, ISettingsService.class);
-        StringCodecFactory stringCodecFactory = settingsService.getStringCodecFactory();
-        return stringCodecFactory.getStringCodec("encoding.display");
+        return CodecUtils.getDisplayNameCodec(getPluginContext());
     }
 
-    protected StringCodec getNodeNameCodec() {
-        ISettingsService settingsService = getPluginContext().getService(ISettingsService.SERVICE_ID, ISettingsService.class);
-        StringCodecFactory stringCodecFactory = settingsService.getStringCodecFactory();
-        return stringCodecFactory.getStringCodec("encoding.node");
+    protected StringCodec getNodeNameCodec(Node node) {
+        return CodecUtils.getNodeNameCodec(getPluginContext(), node);
     }
 
     protected ILocaleProvider getLocaleProvider() {
         return getPluginContext().getService(
                 getPluginConfig().getString(ILocaleProvider.SERVICE_ID, ILocaleProvider.class.getName()),
                 ILocaleProvider.class);
+    }
+
+    private String getCodecLocale() {
+        try {
+            return CodecUtils.getLocaleFromNode(getModel().getNode());
+        } catch (RepositoryException e) {
+            return null;
+        }
     }
 
 }
Index: test/src/test/java/org/hippoecm/frontend/editor/workflow/CopyNameHelperTest.java
IDEA additional info:
Subsystem: com.intellij.openapi.diff.impl.patch.CharsetEP
<+>UTF-8
===================================================================
--- test/src/test/java/org/hippoecm/frontend/editor/workflow/CopyNameHelperTest.java	(revision 48312)
+++ test/src/test/java/org/hippoecm/frontend/editor/workflow/CopyNameHelperTest.java	(revision )
@@ -15,18 +15,21 @@
  */
 package org.hippoecm.frontend.editor.workflow;
 
-import static org.easymock.EasyMock.createMock;
-import static org.easymock.EasyMock.expect;
-import static org.easymock.EasyMock.replay;
-import static org.easymock.EasyMock.verify;
-import static org.junit.Assert.assertEquals;
-
 import javax.jcr.Node;
 import javax.jcr.RepositoryException;
 
+import org.apache.wicket.model.AbstractReadOnlyModel;
+import org.apache.wicket.model.IModel;
+import org.hippoecm.repository.api.StringCodec;
 import org.hippoecm.repository.api.StringCodecFactory.UriEncoding;
 import org.junit.Test;
 
+import static org.easymock.EasyMock.createMock;
+import static org.easymock.EasyMock.expect;
+import static org.easymock.EasyMock.replay;
+import static org.easymock.EasyMock.verify;
+import static org.junit.Assert.assertEquals;
+
 public class CopyNameHelperTest {
     
     @Test
@@ -35,7 +38,7 @@
         expect(folder.hasNode("bla-kopietje")).andReturn(false);
         replay(folder);
 
-        CopyNameHelper helper = new CopyNameHelper(new UriEncoding(), "kopietje");
+        CopyNameHelper helper = new CopyNameHelper(newStringCodecModel(new UriEncoding()), "kopietje");
         assertEquals("bla (kopietje)", helper.getCopyName("bla", folder));
         verify();
     }
@@ -47,7 +50,7 @@
         expect(folder.hasNode("bla-kopietje-2")).andReturn(false);
         replay(folder);
 
-        CopyNameHelper helper = new CopyNameHelper(new UriEncoding(), "kopietje");
+        CopyNameHelper helper = new CopyNameHelper(newStringCodecModel(new UriEncoding()), "kopietje");
         String newName = helper.getCopyName("bla", folder);
         verify();
         assertEquals("bla (kopietje 2)", newName); 
@@ -61,9 +64,19 @@
         expect(folder.hasNode("bla-kopietje-3")).andReturn(false);
         replay(folder);
 
-        CopyNameHelper helper = new CopyNameHelper(new UriEncoding(), "kopietje");
+        CopyNameHelper helper = new CopyNameHelper(newStringCodecModel(new UriEncoding()), "kopietje");
         String newName = helper.getCopyName("bla", folder);
         verify();
         assertEquals("bla (kopietje 3)", newName); 
     }
+
+    private IModel<StringCodec> newStringCodecModel(final StringCodec codec) {
+        return new AbstractReadOnlyModel<StringCodec>() {
+            @Override
+            public StringCodec getObject() {
+                return codec;
+            }
+        };
+    }
+
 }
Index: api/src/main/java/org/hippoecm/frontend/i18n/types/TypeChoiceRenderer.java
IDEA additional info:
Subsystem: com.intellij.openapi.diff.impl.patch.CharsetEP
<+>UTF-8
===================================================================
--- api/src/main/java/org/hippoecm/frontend/i18n/types/TypeChoiceRenderer.java	(revision 48312)
+++ api/src/main/java/org/hippoecm/frontend/i18n/types/TypeChoiceRenderer.java	(revision )
@@ -20,7 +20,7 @@
 import org.apache.wicket.model.StringResourceModel;
 import org.hippoecm.frontend.model.nodetypes.JcrNodeTypeModel;
 
-public class TypeChoiceRenderer implements IChoiceRenderer {
+public class TypeChoiceRenderer implements IChoiceRenderer<String> {
 
     private static final long serialVersionUID = 1L;
 
@@ -30,8 +30,8 @@
         this.component = component;
     }
 
-    public Object getDisplayValue(Object object) {
-        String type = (String) object;
+    @Override
+    public Object getDisplayValue(final String type) {
         JcrNodeTypeModel nodeTypeModel = new JcrNodeTypeModel(type);
         if (nodeTypeModel.getObject() != null) {
             return new TypeTranslator(nodeTypeModel).getTypeName().getObject();
@@ -40,7 +40,8 @@
         }
     }
 
-    public String getIdValue(Object object, int index) {
-        return object.toString();
+    @Override
+    public String getIdValue(final String type, final int index) {
+        return type;
     }
 }
Index: translation/frontend/src/main/java/org/hippoecm/frontend/translation/workflow/TranslationWorkflowPlugin.java
IDEA additional info:
Subsystem: com.intellij.openapi.diff.impl.patch.CharsetEP
<+>UTF-8
===================================================================
--- translation/frontend/src/main/java/org/hippoecm/frontend/translation/workflow/TranslationWorkflowPlugin.java	(revision 48312)
+++ translation/frontend/src/main/java/org/hippoecm/frontend/translation/workflow/TranslationWorkflowPlugin.java	(revision )
@@ -1,5 +1,5 @@
 /*
- *  Copyright 2010-2013 Hippo B.V. (http://www.onehippo.com)
+ *  Copyright 2010-2015 Hippo B.V. (http://www.onehippo.com)
  * 
  *  Licensed under the Apache License, Version 2.0 (the "License");
  *  you may not use this file except in compliance with the License.
@@ -68,12 +68,12 @@
 import org.hippoecm.frontend.translation.components.document.FolderTranslation;
 import org.hippoecm.frontend.types.IFieldDescriptor;
 import org.hippoecm.frontend.types.ITypeDescriptor;
+import org.hippoecm.frontend.util.CodecUtils;
 import org.hippoecm.repository.HippoStdNodeType;
 import org.hippoecm.repository.api.Document;
 import org.hippoecm.repository.api.HippoNode;
 import org.hippoecm.repository.api.HippoWorkspace;
 import org.hippoecm.repository.api.StringCodec;
-import org.hippoecm.repository.api.StringCodecFactory;
 import org.hippoecm.repository.api.Workflow;
 import org.hippoecm.repository.api.WorkflowDescriptor;
 import org.hippoecm.repository.api.WorkflowException;
@@ -325,9 +325,9 @@
                 if (autoTranslateContent) {
                     Workflow translateWorkflow = manager.getWorkflow("translate", translatedVariant);
                     if (translateWorkflow instanceof TranslateWorkflow) {
-                        Set<String> plainTextFields = new TreeSet<String>();
-                        Set<String> richTextFields = new TreeSet<String>();
-                        Set<String> allTextFields = new TreeSet<String>();
+                        Set<String> plainTextFields = new TreeSet<>();
+                        Set<String> richTextFields = new TreeSet<>();
+                        Set<String> allTextFields = new TreeSet<>();
                         String primaryNodeTypeName = session.getNodeByIdentifier(
                                 translatedVariant.getIdentity()).getPrimaryNodeType().getName();
                         collectFields(null, primaryNodeTypeName, plainTextFields, richTextFields);
@@ -700,10 +700,7 @@
     }
 
     protected StringCodec getLocalizeCodec() {
-        ISettingsService settingsService = getPluginContext().getService(ISettingsService.SERVICE_ID,
-                                                                         ISettingsService.class);
-        StringCodecFactory stringCodecFactory = settingsService.getStringCodecFactory();
-        return stringCodecFactory.getStringCodec("encoding.display");
+        return CodecUtils.getDisplayNameCodec(getPluginContext());
     }
 
     @Override
Index: richtext/frontend/src/main/java/org/hippoecm/frontend/plugins/richtext/dialog/images/ImageBrowserDialog.java
IDEA additional info:
Subsystem: com.intellij.openapi.diff.impl.patch.CharsetEP
<+>UTF-8
===================================================================
--- richtext/frontend/src/main/java/org/hippoecm/frontend/plugins/richtext/dialog/images/ImageBrowserDialog.java	(revision 48312)
+++ richtext/frontend/src/main/java/org/hippoecm/frontend/plugins/richtext/dialog/images/ImageBrowserDialog.java	(revision )
@@ -76,6 +76,7 @@
 import org.hippoecm.frontend.plugins.yui.upload.validation.FileUploadValidationService;
 import org.hippoecm.frontend.service.ISettingsService;
 import org.hippoecm.frontend.session.UserSession;
+import org.hippoecm.frontend.util.CodecUtils;
 import org.hippoecm.frontend.validation.IValidationResult;
 import org.hippoecm.frontend.validation.ValidationException;
 import org.hippoecm.frontend.widgets.ThrottledTextFieldWidget;
@@ -394,7 +395,7 @@
                         Node folderNode = getFolderModel().getObject();
 
                         //TODO replace shortcuts with custom workflow category(?)
-                        String nodeName = getNodeNameCodec().encode(filename);
+                        String nodeName = getNodeNameCodec(folderNode).encode(filename);
                         localName = getLocalizeCodec().encode(filename);
                         GalleryWorkflow workflow = (GalleryWorkflow) manager.getWorkflow("gallery", folderNode);
                         Document document = workflow.createGalleryItem(nodeName, getGalleryType());
@@ -523,16 +524,12 @@
         return new DefaultGalleryProcessor();
     }
 
-    private StringCodec getNodeNameCodec() {
-        ISettingsService settingsService = getPluginContext().getService(ISettingsService.SERVICE_ID, ISettingsService.class);
-        StringCodecFactory stringCodecFactory = settingsService.getStringCodecFactory();
-        return stringCodecFactory.getStringCodec("encoding.node");
+    private StringCodec getNodeNameCodec(Node node) {
+        return CodecUtils.getNodeNameCodec(getPluginContext(), node);
     }
 
     private StringCodec getLocalizeCodec() {
-        ISettingsService settingsService = getPluginContext().getService(ISettingsService.SERVICE_ID, ISettingsService.class);
-        StringCodecFactory stringCodecFactory = settingsService.getStringCodecFactory();
-        return stringCodecFactory.getStringCodec("encoding.display");
+        return CodecUtils.getDisplayNameCodec(getPluginContext());
     }
 
     private String getGalleryType() {
Index: api/src/main/java/org/hippoecm/frontend/editor/workflow/CopyNameHelper.java
IDEA additional info:
Subsystem: com.intellij.openapi.diff.impl.patch.CharsetEP
<+>UTF-8
===================================================================
--- api/src/main/java/org/hippoecm/frontend/editor/workflow/CopyNameHelper.java	(revision 48312)
+++ api/src/main/java/org/hippoecm/frontend/editor/workflow/CopyNameHelper.java	(revision )
@@ -1,5 +1,5 @@
 /*
- *  Copyright 2010-2013 Hippo B.V. (http://www.onehippo.com)
+ *  Copyright 2010-2015 Hippo B.V. (http://www.onehippo.com)
  * 
  *  Licensed under the Apache License, Version 2.0 (the "License");
  *  you may not use this file except in compliance with the License.
@@ -21,17 +21,23 @@
 import javax.jcr.Node;
 import javax.jcr.RepositoryException;
 
+import org.apache.wicket.model.AbstractReadOnlyModel;
+import org.apache.wicket.model.IModel;
 import org.hippoecm.repository.api.StringCodec;
 
 public class CopyNameHelper {
 
     private final Pattern firstcopy;
     private final Pattern othercopies;
-    private final StringCodec codec;
+    private final IModel<StringCodec> codecModel;
     private final String copyOf;
 
     public CopyNameHelper(StringCodec codec, String copyOf) {
-        this.codec = codec;
+        this(createModel(codec), copyOf);
+    }
+
+    public CopyNameHelper(IModel<StringCodec> codecModel, String copyOf) {
+        this.codecModel = codecModel;
         this.copyOf = copyOf;
         this.firstcopy = Pattern.compile(".* \\(" + copyOf + "\\)$");
         this.othercopies = Pattern.compile(".* \\(" + copyOf + " ([0-9]*?)\\)$");
@@ -61,7 +67,7 @@
                 } else {
                     name = base + " (" + copyOf + " " + (number) + ")";
                 }
-                nodeName = codec.encode(name);
+                nodeName = codecModel.getObject().encode(name);
                 number++;
             } while (folder.hasNode(nodeName));
         } else {
@@ -69,4 +75,14 @@
         }
         return name;
     }
+
+    private static IModel<StringCodec> createModel(final StringCodec codec) {
+        return new AbstractReadOnlyModel<StringCodec>() {
+            @Override
+            public StringCodec getObject() {
+                return codec;
+            }
+        };
+    }
+
 }
Index: builtin/src/main/java/org/hippoecm/frontend/plugins/standardworkflow/components/LanguageField.java
IDEA additional info:
Subsystem: com.intellij.openapi.diff.impl.patch.CharsetEP
<+>UTF-8
===================================================================
--- builtin/src/main/java/org/hippoecm/frontend/plugins/standardworkflow/components/LanguageField.java	(revision 48312)
+++ builtin/src/main/java/org/hippoecm/frontend/plugins/standardworkflow/components/LanguageField.java	(revision )
@@ -1,5 +1,5 @@
 /*
- * Copyright 2010-2013 Hippo B.V. (http://www.onehippo.com)
+ * Copyright 2010-2015 Hippo B.V. (http://www.onehippo.com)
  * 
  * Licensed under the Apache License, Version 2.0 (the "License");
  * you may not use this file except in compliance with the License.
@@ -20,6 +20,8 @@
 import java.util.Comparator;
 import java.util.List;
 
+import org.apache.wicket.ajax.AjaxRequestTarget;
+import org.apache.wicket.ajax.form.AjaxFormComponentUpdatingBehavior;
 import org.apache.wicket.markup.html.WebMarkupContainer;
 import org.apache.wicket.markup.html.form.DropDownChoice;
 import org.apache.wicket.markup.html.form.IChoiceRenderer;
@@ -30,15 +32,13 @@
 public class LanguageField extends WebMarkupContainer {
     private static final long serialVersionUID = 1L;
 
-    private final DropDownChoice<String> languageChoice;
-
     public LanguageField(String id, IModel<String> languageModel, final ILocaleProvider provider) {
         super(id);
 
         List<String> languages = Collections.emptyList();
         if (provider != null) {
             List<? extends HippoLocale> locales = provider.getLocales();
-            ArrayList<HippoLocale> ordered = new ArrayList<HippoLocale>(locales);
+            ArrayList<HippoLocale> ordered = new ArrayList<>(locales);
             Collections.sort(ordered, new Comparator<HippoLocale>() {
 
                 @Override
@@ -47,17 +47,21 @@
                 }
 
             });
-            languages = new ArrayList<String>(ordered.size());
+            languages = new ArrayList<>(ordered.size());
             for (HippoLocale locale : ordered) {
                 languages.add(locale.getName());
             }
         }
-        add(languageChoice = new DropDownChoice<String>("select", languageModel, languages,
+
+        final DropDownChoice<String> languageChoice;
+        add(languageChoice = new DropDownChoice<>("select", languageModel, languages,
                 new IChoiceRenderer<String>() {
                     private static final long serialVersionUID = 1L;
 
-                    @SuppressWarnings("null")
                     public Object getDisplayValue(String object) {
+                        if (provider == null) {
+                            return object;
+                        }
                         return provider.getLocale(object).getDisplayName(getLocale());
                     }
 
@@ -68,7 +72,17 @@
                 }));
         languageChoice.setNullValid(false);
         languageChoice.setRequired(true);
+        languageChoice.add(new AjaxFormComponentUpdatingBehavior("onchange") {
+
+            @Override
+            protected void onUpdate(final AjaxRequestTarget target) {
+                LanguageField.this.onSelectionChanged();
+            }
+        });
         setOutputMarkupPlaceholderTag(true);
+    }
+
+    protected void onSelectionChanged() {
     }
 
 }
Index: gallery/frontend/src/main/java/org/hippoecm/frontend/plugins/gallery/GalleryShortcutPlugin.java
IDEA additional info:
Subsystem: com.intellij.openapi.diff.impl.patch.CharsetEP
<+>UTF-8
===================================================================
--- gallery/frontend/src/main/java/org/hippoecm/frontend/plugins/gallery/GalleryShortcutPlugin.java	(revision 48312)
+++ gallery/frontend/src/main/java/org/hippoecm/frontend/plugins/gallery/GalleryShortcutPlugin.java	(revision )
@@ -1,5 +1,5 @@
 /*
- *  Copyright 2008-2013 Hippo B.V. (http://www.onehippo.com)
+ *  Copyright 2008-2015 Hippo B.V. (http://www.onehippo.com)
  * 
  *  Licensed under the Apache License, Version 2.0 (the "License");
  *  you may not use this file except in compliance with the License.
@@ -15,6 +15,8 @@
  */
 package org.hippoecm.frontend.plugins.gallery;
 
+import javax.jcr.Node;
+
 import org.apache.wicket.ajax.AjaxRequestTarget;
 import org.apache.wicket.ajax.markup.html.AjaxLink;
 import org.apache.wicket.markup.html.basic.Label;
@@ -25,7 +27,7 @@
 import org.hippoecm.frontend.plugins.gallery.upload.UploadDialog;
 import org.hippoecm.frontend.service.render.RenderPlugin;
 
-public class GalleryShortcutPlugin extends RenderPlugin {
+public class GalleryShortcutPlugin extends RenderPlugin<Node> {
     private static final long serialVersionUID = 1L;
 
     public GalleryShortcutPlugin(IPluginContext context, IPluginConfig config) {
@@ -39,7 +41,7 @@
                 IDialogService dialogService = getDialogService();
                 UploadDialog dialog = new UploadDialog(GalleryShortcutPlugin.this.getPluginContext(),
                                                        GalleryShortcutPlugin.this.getPluginConfig(),
-                                                       GalleryShortcutPlugin.this.getDefaultModel());
+                                                       GalleryShortcutPlugin.this.getModel());
                 dialogService.show(dialog);
             }
         };
Index: builtin/src/main/java/org/hippoecm/frontend/plugins/standardworkflow/RenameDocumentDialog.java
IDEA additional info:
Subsystem: com.intellij.openapi.diff.impl.patch.CharsetEP
<+>UTF-8
===================================================================
--- builtin/src/main/java/org/hippoecm/frontend/plugins/standardworkflow/RenameDocumentDialog.java	(revision 48312)
+++ builtin/src/main/java/org/hippoecm/frontend/plugins/standardworkflow/RenameDocumentDialog.java	(revision )
@@ -34,31 +34,33 @@
 import org.apache.wicket.util.value.IValueMap;
 import org.hippoecm.addon.workflow.AbstractWorkflowDialog;
 import org.hippoecm.addon.workflow.IWorkflowInvoker;
+import org.hippoecm.frontend.dialog.DialogConstants;
 import org.hippoecm.frontend.plugins.standards.list.resolvers.CssClassAppender;
 import org.hippoecm.frontend.session.UserSession;
 import org.hippoecm.repository.api.StringCodec;
 
 public class RenameDocumentDialog extends AbstractWorkflowDialog<RenameDocumentArguments> {
-    private IModel title;
+
+    private IModel<String> title;
     private TextField nameComponent;
     private TextField uriComponent;
     private boolean uriModified;
     private final IModel<StringCodec> nodeNameCodecModel;
 
-    public RenameDocumentDialog(RenameDocumentArguments renameDocumentModel, IModel title, IWorkflowInvoker invoker,
-            IModel<StringCodec> nodeNameCodec) {
+    public RenameDocumentDialog(RenameDocumentArguments renameDocumentModel, IModel<String> title,
+                                IWorkflowInvoker invoker, IModel<StringCodec> nodeNameCodec) {
         super(Model.of(renameDocumentModel), invoker);
         this.title = title;
         this.nodeNameCodecModel = nodeNameCodec;
 
-        final PropertyModel<String> nameModel = new PropertyModel<String>(renameDocumentModel, "targetName");
-        final PropertyModel<String> uriModel = new PropertyModel<String>(renameDocumentModel, "uriName");
+        final PropertyModel<String> nameModel = new PropertyModel<>(renameDocumentModel, "targetName");
+        final PropertyModel<String> uriModel = new PropertyModel<>(renameDocumentModel, "uriName");
 
         String s1 = nameModel.getObject();
         String s2 = uriModel.getObject();
         uriModified = !s1.equals(s2);
 
-        nameComponent = new TextField<String>("name", nameModel);
+        nameComponent = new TextField<>("name", nameModel);
         nameComponent.setRequired(true);
         nameComponent.setLabel(new StringResourceModel("name-label", this, null));
         nameComponent.add(new OnChangeAjaxBehavior() {
@@ -126,17 +128,17 @@
         final RenameMessage message = new RenameMessage(cmsLocale, renameDocumentModel.getLocalizedNames());
         if (message.shouldShow()) {
             warn(message.forFolder());
-        };
-    }
+        }
+    }
 
     @Override
-    public IModel getTitle() {
+    public IModel<String> getTitle() {
         return title;
     }
 
     @Override
     public IValueMap getProperties() {
-        return MEDIUM;
+        return DialogConstants.MEDIUM;
     }
 
     protected StringCodec getNodeNameCodec() {
